/**
 **	File ......... ForumsForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include <libibank.h>
#include "ForumsForm.h"




ForumsForm::ForumsForm(Web *w) : BaseForm(w, "ForumsForm")
{
}


ForumsForm::~ForumsForm()
{
}


void ForumsForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
//	Database& db = pWeb -> GetDatabase();
	char action[200];

	// <input type="submit" name="ForumsForm" value="action" ...
	if (GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) && *action)
	{
		if (!strcmp(action,"select"))
		{
			long nr = atol(GetForm() -> getvalue("forum").c_str());
			pWeb -> SetForum( nr );
			pWeb -> SetPage( 4 );
		}
	}
}


void ForumsForm::Display(long)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	Query q(&db);
	Query q2(&db);
	Query q3(&db);
	char sql[1000];

//	printf("<h3>Forums</h3>");
	Navigator();
	printf("</td><td align=right>");
//	printf("<div align=right>");
	printf("[ <a href=\"%s?page=2\">settings</a> ",GetCgiName().c_str());
	printf("| <a href=\"%s?logout=1\">logout</a> ",GetCgiName().c_str());
//	printf("]</div>");
	printf("]</td></tr></table>");
	printf("</div>");

	q.get_result("select * from forum where deleted=0 order by updated desc");
	printf("<table cellpadding=\"0\" cellspacing=\"0\" class=forums width=\"100%%\">");
	printf("<tr>");
	printf("<th class=forums align=left>Forum</th>");
	printf("<th class=forums align=left>Topics</th>");
	printf("<th class=forums align=left>Messages</th>");
	printf("<th class=forums align=left>Last</th>");
	printf("</tr>");
	while (q.fetch_row())
	{
		db::Forum x(&db, &q);
		db::Account account(db, x.updated_by);
		long qthreads = 0;
		long qmessages = 0;

		sprintf(sql,"select num from thread where forum=%ld and deleted=0",x.num);
		q2.get_result(sql);
		while (q2.fetch_row())
		{
			long num = q2.getval();
			sprintf(sql,"select count(*) from message where thread=%ld and deleted=0",num);
			qmessages += q3.get_count(sql);
			qthreads++;
		}
		q2.free_result();

		printf("<tr>");
		printf("<td class=forums><a href=\"%s?ForumsForm=select&forum=%ld\">%s</a></td>",
			GetCgiName().c_str(),x.num,x.name.c_str());
		printf("<td class=forums align=right width=\"1%%\">%ld</td>",qthreads);
		printf("<td class=forums align=right width=\"1%%\">%ld</td>",qmessages);
		printf("<td class=forums width=\"1%%\">");
		printf("%s<br>",GetAccountName(account).c_str());
		nbprintf("%s</td>", x.updated.c_str());
		printf("</tr>");
	}
	printf("</table>");
	q.free_result();
}


