/**
 **	File ......... EditMessageForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include "EditMessageForm.h"

/*
#define DEB(x) { \
	FILE *fil = fopen("/tmp/debug","at"); \
	x; \
	fclose(fil); \
}
*/
#define DEB(x)


EditMessageForm::EditMessageForm(Web *w) : BaseForm(w, "EditMessageForm")
{
}


EditMessageForm::~EditMessageForm()
{
}


void EditMessageForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	char action[200];

	// <input type="submit" name="EditMessageForm" value="action" ...
	if (!GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) || !*action)
	{
		return;
	}
	if (!strcmp(action," Update "))
	{
		std::string title = GetForm() -> getvalue("title");
		std::string message_body = GetForm() -> getvalue("message");
		long image_num = 0;
		char fn[1000];

		GetForm() -> getvalue("the_file",fn,255);
		if (!strncmp(fn,"/tmp/",5) && strlen(fn) > 5)
		{
			image_num = AddImage(pWeb -> GetUsernum(), fn);
		}
		db::Forum forum(db,pWeb -> GetForum());
		forum.updated = GetDate();
		forum.updated_by = pWeb -> GetUsernum();
		forum.save();
		db::Thread thread(db,pWeb -> GetThread());
		thread.updated = GetDate();
		thread.updated_by = pWeb -> GetUsernum();
		thread.save();
		db::Message message(db, pWeb -> GetMessage());
		message.title = title;
		message.body = message_body;
		message.version++;
		message.updated = GetDate();
		if (message.posted_by == pWeb -> GetUsernum())
		{
			char value[1000];
			bool r = GetForm() -> getfirst(fn, 1000, value, 1000);
			message.save();
			while (r)
			{
DEB(				fprintf(fil,"'%s' == '%s'\n",fn,value);)
				if (!strcmp(fn, "delete"))
				{
					long num = atol(value);
					db::Linkmessageimage x(db, num);
					if (x.message == message.num)
					{
						x.deleted = 1;
						x.save();
					}
				}
				//
				r = GetForm() -> getnext(fn, 1000, value, 1000);
			}
		}
		if (image_num > 0)
		{
			db::Linkmessageimage x(&db);
			x.message = message.num;
			x.image = image_num;
			x.save();
		}
		pWeb -> SetPage( 5 ); // View Thread
	}
	else
	if (!strcmp(action," Delete Message "))
	{
		db::Message message(db, pWeb -> GetMessage());
		if (message.posted_by == pWeb -> GetUsernum())
		{
			message.deleted++;
			message.save();
		}
		pWeb -> SetPage( 5 );
	}
}


void EditMessageForm::Display(long)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	Query q(db);
	db::Message message(db, pWeb -> GetMessage());
	char sql[1000];

//	printf("<h3>Edit message</h3>");
	Navigator(pWeb -> GetForum(),pWeb -> GetThread(),pWeb -> GetMessage());
	printf("</td><td align=right>");
//	printf("<div align=right>");
	printf("[ <a href=\"%s?page=2\">settings</a> ",GetCgiName().c_str());
	printf("| <a href=\"%s?logout=1\">logout</a> ",GetCgiName().c_str());
//	printf("]</div>");
	printf("]</td></tr></table>");
	printf("</div>");

	printf("<form action=\"%s\" method=post enctype=\"multipart/form-data\">",
		GetCgiName().c_str());
	printf("Add picture (optional)<br>");
	printf("<input type=file name=the_file><br>");
	printf("Title<br>");
	printf("<input type=text name=title size=40 value=\"%s\"><br>", message.title.c_str());
	printf("Message<br>");
	printf("<textarea name=message rows=10 cols=80>");
	viewtext(message.body, true);
	printf("</textarea><br>"); //, message.body.c_str() );
	sprintf(sql,"select * from linkmessageimage where message=%ld and deleted=0",message.num);
	q.get_result(sql);
	printf("<table cellpadding=\"0\" cellspacing=\"0\" class=editmessage>");
	printf("<tr><th>Delete</th><th>Image</th></tr>");
	while (q.fetch_row())
	{
		db::Linkmessageimage x(&db,&q);
		printf("<tr><td class=editmessage align=center><input type=checkbox name=delete value=%ld></td>",x.num);
		printf("<td class=editmessage>");
		viewtn( x.image );
/*
		printf("<a href=\"%s?img=%ld\"><img border=\"0\" alt=\"Thumbnail\" src=\"%s?imgtn=%ld\"></a>",
			GetCgiName().c_str(),x.image,
			GetCgiName().c_str(),x.image);
*/
		printf("</td></tr>");
	}
	printf("</table>");
	q.free_result();
	printf("&nbsp;&nbsp;&nbsp;");
	printf("<input type=submit name=\"%s\" value=\" Update \">",GetFormName().c_str());
	printf("&nbsp;&nbsp;&nbsp;");
	printf("<input type=submit name=\"%s\" value=\" Delete Message \">",GetFormName().c_str());
	printf("</form>");
}


